<?php
/*
Plugin Name: Readers_Post 
Plugin URI: http://www.aufzynden.de/post-readers-wp-plugin/
Description: Zeigt die Anzahl der Leser pro Artikel an
Version: 1.1b
Author: Stefan Groenveld
Author URI: http://www.aufzynden.de
*/

if(!isset($wpdb->post_counter))
	$wpdb->post_counter = $table_prefix . "post_counter";
	if(!isset($wpdb->post_counter_time))
	$wpdb->post_counter_time = $table_prefix . "post_counter_time";
	
if(isset($_GET['activate']) && $_GET['activate'] == 'true')
add_action('init', 'setupReader');
add_action('wp_head', 'writeReader');

//  Setup inkl. Erstellen der Tabelle 
function setupReader() {
global $user_level, $wpdb;

get_currentuserinfo();
if ($user_level > 8)
{
if($wpdb->get_var("SHOW TABLES LIKE '$wpdb->post_counter'") != $wpdb->post_counter)
            {
            require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
                $sql = "CREATE TABLE `$wpdb->post_counter` (
`post_id` int(11) unsigned,
`post_count` int(11) unsigned NOT NULL,
`time` datetime NOT NULL default '0000-00-00 00:00:00',
PRIMARY KEY  (`post_id`)) TYPE=MyISAM;";                
dbDelta($sql);
}
if($wpdb->get_var("SHOW TABLES LIKE '$wpdb->post_counter_time'") != $wpdb->post_counter_time)
            {
            require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
                $sql = "CREATE TABLE `$wpdb->post_counter_time` (
                `post_id` int(11) unsigned NOT NULL default '0',
					`time` datetime NOT NULL default '0000-00-00 00:00:00'
					) TYPE=MyISAM;";                
dbDelta($sql);
}

}
}

function writeReader() {
global $wpdb, $wp_query;

	if (is_page() || is_single){
		$postID = $wp_query->post->ID;
	}
	if (is_home() || is_archive()){
		$postID = 0;
	}

$postID = ($postID == NULL ? 0 : $postID); 

$vorhanden = $wpdb->get_var("SELECT count(*) as vorhanden FROM `$wpdb->post_counter` where `post_id` =".$postID." LIMIT 0,1");

		if (!current_user_can('level_2')){
	if ($vorhanden == 1){
		$sql = "UPDATE `$wpdb->post_counter` SET `post_count` = (`post_count`+1),`time` = NOW() WHERE `post_id` = $postID";
		$wpdb->query($sql);        
	}else{
		$sql = "INSERT INTO `$wpdb->post_counter`(post_id, post_count, time) VALUES($postID,1,now())";
		$wpdb->query($sql);
	}
	if ($postID != 0){
		$sql = "INSERT INTO `$wpdb->post_counter_time` (post_id, time) VALUES($postID,now())";
		$wpdb->query($sql);
		      
	}
}



function readers($before='This post was read by ', $after=' people until now.', $display = true) {
	global $post;
	global $wpdb;
	
	$id = $post->ID;
	
$post_readers = $wpdb->get_var("SELECT ".$wpdb->post_counter.".post_count AS anzahl FROM ".$wpdb->post_counter." WHERE ".$wpdb->post_counter.".post_id = ".$id." LIMIT 0,1");
		
	$post_readers = ($post_readers == "" ? 0 : $post_readers);
	
		if($display) {
			echo $before . $post_readers . $after;
		} else {
			return $post_readers;
		}
		
}

function last_posts($limit = 5, $cut_off = 0, $before='<li>', $after='</li>'){
	global $wpdb;
	$home = get_option('siteurl');

	$lastXs = $wpdb->get_results("SELECT ".$wpdb->posts.".ID AS ID,".$wpdb->posts.".post_title AS TITLE ,".$wpdb->post_counter.".post_count AS ZAEHLER FROM ".$wpdb->posts.",".$wpdb->post_counter." where ".$wpdb->post_counter.".post_id = ".$wpdb->posts.".ID AND (".$wpdb->posts.".post_status = 'static' OR ".$wpdb->posts.".post_status = 'publish') order by ".$wpdb->post_counter.".time DESC limit 0,".$limit);

		foreach ($lastXs as $lastX) {
			$nummer = $lastX->ID;
			$title = $lastX->TITLE;
			$title = wptexturize($title);
			if ($cut_off>0){
				$title_short = substr($title,0,$cut_off);
			}else{
				$title_short =$title;
			}
			$hotposts = $lastX->ZAEHLER;
			
			echo $before . "<a href='".get_permalink($nummer)."' title='".$title."'>". $title_short . " (".$hotposts." Leser) </a>" . $after;
		}

}

function hot_posts($limit = 5, $cut_off = 0, $before='<li>', $after='</li>'){
	global $wpdb;
	$home = get_option('siteurl');

	$lastXs = $wpdb->get_results("SELECT ".$wpdb->posts.".ID AS ID,".$wpdb->posts.".post_title AS TITLE ,".$wpdb->post_counter.".post_count AS ZAEHLER FROM ".$wpdb->posts.",".$wpdb->post_counter." where ".$wpdb->post_counter.".post_id = ".$wpdb->posts.".ID AND (".$wpdb->posts.".post_status = 'static' OR ".$wpdb->posts.".post_status = 'publish') order by ".$wpdb->post_counter.".post_count DESC limit 0,".$limit);

		foreach ($lastXs as $lastX) {
			$nummer = $lastX->ID;
			$title = $lastX->TITLE;
			$title = wptexturize($title);
			if ($cut_off>0){
				$title_short = substr($title,0,$cut_off);
			}else{
				$title_short = $title;
			}
			$hotposts = $lastX->ZAEHLER;
						
			echo $before . "<a href='".get_permalink($nummer)."' title='".$title."'>". $title_short . " (".$hotposts." Leser) </a>" . $after;
		}

}



function hot_posts_last($limit = 5, $cut_off = 0, $before='<li>', $after='</li>'){
	global $wpdb;
	$home = get_option('siteurl');
	$i = 0;
		
	$query_delete = "DELETE FROM $wpdb->post_counter_time where time < DATE_SUB(NOW(), INTERVAL 14 DAY);";
	$wpdb->query($query_delete);


	$lastXs = $wpdb->get_results("SELECT ".$wpdb->posts.".ID AS ID,".$wpdb->posts.".post_title AS TITLE, count($wpdb->post_counter_time.post_id) AS ZAEHLER, date_format(max($wpdb->post_counter_time.time),'%d.%m.%Y \u\m %H:%i') AS Zeit FROM ".$wpdb->posts.",$wpdb->post_counter_time where $wpdb->post_counter_time.post_id = ".$wpdb->posts.".ID AND (".$wpdb->posts.".post_status = 'static' OR ".$wpdb->posts.".post_status = 'publish') group by ID order by ZAEHLER DESC");
	
	$a = (count($lastXs) > 10 ? 10 : count($lastXs));
	
	while ($i < $a) {
			$nummer = $lastXs[$i]->ID;
			$title = $lastXs[$i]->TITLE;
			$title = wptexturize($title);
			if ($cut_off>0){
				$title_short = substr($title,0,$cut_off);
			}else{
				$title_short = $title;
			}
			$hotposts = $lastXs[$i]->ZAEHLER;
			$zuletzt = $lastXs[$i]->Zeit;
$i++;            // Inkrementierung der Laufvariablen
			
			
			
			echo $before . "<a href='".get_permalink($nummer)."' title='".$title."'>". $title_short . "</a> (".$hotposts." Leser - zuletzt am ".$zuletzt." Uhr)" . $after;
		
} 
}


function readers_total() {
	global $post;
	global $wpdb;
	
	$id = $post->ID;
	
$post_readers_total = $wpdb->get_var("SELECT count(*) FROM `$wpdb->post_counter_time`");
		
	$post_readers_total = ($post_readers_total == "" ? 0 : $post_readers_total);
	
		echo "In den letzten 14 Tagen wurden die Artikel insgesamt " . $post_readers_total . "mal gelesen.";
		
}


}
?>